nflagimg="gfx/neutral_flag.png"

initpos = {15,15}

carrier = 0
nfimg = {}
nfpos = initpos
nffimg = image(nflagimg,nfpos[1]*32+16,nfpos[2]*32+16,1)
nftimer = 0
nfscore = {0,0}

nflimit = 1000 -- point limit
nfflag = 10 -- how much points for holding flag
nfcap = 1 -- for capturing flag
nfkill = 2 -- for killing carrier
nfftime = 5 -- seconds to hold for to get nfflag

function hudtxt(id,colour,text,x,y,align)
	align = align or ""
	local print="\""..colour..text.."\""
	parse("hudtxt "..id.." "..print.." "..x.." "..y.." "..align)
end

function teammsg(t,txt)
	if t==1 then
		msg("255000000"..txt)
	elseif t==2 then
		msg("000000255"..txt)
	elseif t==0 then
		msg("255255000"..txt)
	end
	return nil
end

function teamname(t)
	if t==0 then
		return "Spectators"
	elseif t==1 then
		return "Terrorists"
	elseif t==2 then
		return "Counter-Terrorists"
	end
	return nil
end

function teamcolour(t)
	if t==1 then
		return "255000000"
	elseif t==2 then
		return "000000255"
	elseif t==0 then
		return "255255000"
	end
	return nil
end

addhook("movetile","pickupflag")
function pickupflag(id,x,y)
	if x==nfpos[1] and y==nfpos[2] then
		carrier = id
		freeimage(nffimg)
		nfimg[id] = image(nflagimg,1,0,200+id)
		teammsg(player(id,"team"),player(id,"name").." has picked up the flag!@C")
		nfscore[player(carrier,"team")] = nfscore[player(carrier,"team")] + nfcap
	end
end

addhook("die","dropflag")
function dropflag(id,k)
	teammsg(player(id,"team"),player(id,"name").." has dropped the flag!@C")
	carrier = 0
	freeimage(nfimg[id])
	nfpos = {player(id,"tilex"),player(id,"tiley")}
	nffimg = image(nflagimg,player(id,"x"),player(id,"y"),1)
	if k~=0 then
		parse("setscore "..k.." "..player(k,"score")+1)
		nfscore[player(k,"team")] = nfscore[player(k,"team")] + nfkill
	end
end

addhook("second","ntimer")
function ntimer()
	nftimer = nftimer + 1
	if nftimer>=nfftime then
		if carrier~=0 then
			nfscore[player(carrier,"team")] = nfscore[player(carrier,"team")] + nfflag
		end
		nftimer=0
	end
	for i=1,2 do
		if nfscore[i]>=nflimit then
			teammsg(i,teamname(i).." have won the round!@C")
			timer(5000,"parse","restart")
		end
	end
	hudtxt(10,"255000000","Terrorists: "..nfscore[1],150,5)
	hudtxt(11,"000000255","Counter-Terrorists: "..nfscore[2],350,5)
	hudtxt(12,"255255000","Playing until: "..nflimit,240,15)
end

addhook("startround","redo")
function redo()
	carrier = 0
	freeimage(nffimg)
	for k,i in pairs(nfimg) do
		freeimage(i)
		nfimg[k] = 0
	end
	nfpos = initpos
	nffimg = image(nflagimg,nfpos[1]*32+16,nfpos[2]*32+16,1)
	nftimer = 0

	nfscore = {0,0}
	nflimit = 100
end